PassVerifier (jakarta-bcel 5.1 API)
Keywords: org.apache.bcel.verifier.PassVerifier,PassVerifier class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.bcel.verifier
Class PassVerifier

    java.lang.Object
      |
      +--org.apache.bcel.verifier.PassVerifier

Direct Known Subclasses:
  Pass1Verifier, Pass2Verifier, Pass3aVerifier, Pass3bVerifier

public abstract class PassVerifier
extends java.lang.Object

A PassVerifier actually verifies a class file; it is instantiated by a Verifier. The verification should conform with a certain pass as described in The Java Virtual Machine Specification, 2nd edition. This book describes four passes. Pass one means loading the class and verifying a few static constraints. Pass two actually verifies some other constraints that could enforce loading in referenced class files. Pass three is the first pass that actually checks constraints in the code array of a method in the class file; it has two parts with the first verifying static constraints and the second part verifying structural constraints (where a data flow analysis is used for). The fourth pass, finally, performs checks that can only be done at run-time. JustIce does not have a run-time pass, but certain constraints that are usually delayed until run-time for performance reasons are also checked during the second part of pass three. PassVerifier instances perform caching. That means, if you really want a new verification run of a certain pass you must use a new instance of a given PassVerifier.

Version:
  $Id: PassVerifier.java,v 1.1.1.1 2001/10/29 20:00:31 jvanzyl Exp $
Author:
  Enver Haase
See Also:
  `Verifier`, `verify()`

Constructor Summary
`PassVerifier()`

Method Summary
`void` | `addMessage(java.lang.String message)` This method adds a (warning) message to the message pool of this PassVerifier.
`abstract VerificationResult` | `do_verify()` Does the real verification work, uncached.
`java.lang.String[]` | `getMessages()` Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.
`VerificationResult` | `verify()` This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PassVerifier

    public PassVerifier()

Method Detail

### verify

    public VerificationResult verify()

  This method runs a verification pass conforming to the Java Virtual Machine Specification, 2nd edition, on a class file. PassVerifier instances perform caching; i.e. if the verify() method once determined a VerificationResult, then this result may be returned after every invocation of this method instead of running the verification pass anew; likewise with the result of getMessages().

  See Also:
    `getMessages()`, `addMessage(String)`

### do_verify

    public abstract VerificationResult do_verify()

  Does the real verification work, uncached.

### addMessage

    public void addMessage(java.lang.String message)

  This method adds a (warning) message to the message pool of this PassVerifier. This method is normally only internally used by BCEL's class file verifier "JustIce" and should not be used from the outside.

  See Also:
    `getMessages()`

### getMessages

    public java.lang.String[] getMessages()

  Returns the (warning) messages that this PassVerifier accumulated during its do_verify()ing work.

  See Also:
    `addMessage(String)`, `do_verify()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2003 Apache Software Foundation. All Rights Reserved.